unit uFenster;
(* ******************************************************************** *)
(* K L A S S E : TFenster                                               *)
(* -------------------------------------------------------------------- *)
(* Version     : V. 1.1                                                 *)
(* Autor       : (c) S. Spolwig - OSZ Handel I, 10997 Berlin            *)
(* Beschreibung: TFenster ist das GUI fuer das Programm Billard.        *)
(*                                                                      *)
(* Compiler    : Delphi 3.0                                             *)
(* Aenderungen : V 1.0  -   14-JAN-99                                   *)
(*								 1.1	- 	14-JUN-01	SetLink														*)		
(* ******************************************************************** *)
interface
(* ==================================================================== *)
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls,
  uGrafik,  // import: Zeichenblatt
  uKugel ;  // import: TKugel

type
  TFensterFrm = class(TForm)
    SteuerPnl : TPanel;
    TischImg  : TImage;
    StopBtn   : TButton;
    StartBtn  : TButton;
    EndeBtn   : TButton;

    procedure FormCreate(Sender: TObject);
    procedure StopBtnClick(Sender: TObject);
    procedure StartBtnClick(Sender: TObject);
    procedure EndeBtnClick(Sender: TObject);

   private
    procedure AlleKugelnRollen;
  end;

var
  FensterFrm  : TFensterFrm;
  Tisch       : TZeichenblatt;
  WeisseKugel,
  GelbeKugel,
  RoteKugel   : TKugel;

implementation
(* ==================================================================== *)
{$R *.DFM}

var StopGedrueckt : boolean;


procedure TFensterFrm.FormCreate(Sender: TObject);
(* -------------------------------------------------------------------- *)
begin
  Tisch := TZeichenblatt.Create;
  Tisch.SetLink (TischImg);
  Tisch.SetFuellFarbe(clGreen);
  Tisch.Zeigen;

  WeisseKugel := TKugel.Create;
  WeisseKugel.SetRadius(15);
  WeisseKugel.SetFuellFarbe(clWhite);
  WeisseKugel.SetPos(100,200);
  WeisseKugel.Setlink(Tisch);

  RoteKugel := TKugel.Create;
  RoteKugel.SetRadius(15);
  RoteKugel.SetFuellFarbe(clRed);
  RoteKugel.SetPos(450,80);
  RoteKugel.Setlink(Tisch);

  GelbeKugel := TKugel.Create;
  GelbeKugel.SetRadius(15);
  GelbeKugel.SetFuellFarbe(clyellow);
  GelbeKugel.SetPos(450,140);
  GelbeKugel.Setlink(Tisch);

  WeisseKugel.Zeigen;
  RoteKugel.Zeigen;
  GelbeKugel.Zeigen;
end;


procedure TFensterFrm.StopBtnClick(Sender: TObject);
(* -------------------------------------------------------------------- *)
begin
  StopGedrueckt := true;
end;



procedure TFensterFrm.StartBtnClick(Sender: TObject);
(* -------------------------------------------------------------------- *)
(* Aufgage : Richtung der Kugel festlegen und AlleKugelRollen bis       *)
(*           StopGedrueckt ist.                                         *)
(* -------------------------------------------------------------------- *)
begin
  StopGedrueckt := false;
  WeisseKugel.SetXRichtung(3);
  WeisseKugel.SetYRichtung(-1);

  RoteKugel.SetXRichtung(-5);
  RoteKugel.SetYRichtung(-1);

  GelbeKugel.SetXRichtung(-6);
  GelbeKugel.SetYRichtung(-2);

  repeat
    AlleKugelnRollen;
  until StopGedrueckt;
end;


procedure TFensterFrm.EndeBtnClick(Sender: TObject);
(* -------------------------------------------------------------------- *)
begin
  FensterFrm.Close;
end;


procedure TFensterFrm.AlleKugelnRollen;
(* -------------------------------------------------------------------- *)
begin
  WeisseKugel.Bewegen;
  RoteKugel.Bewegen;
  GelbeKugel.Bewegen;

  if WeisseKugel.Trifft(RoteKugel)
  then
    begin
      beep;
      WeisseKugel.RichtungTauschenMit (RoteKugel);
    end
  else
    if WeisseKugel.Trifft(GelbeKugel)
    then
      begin
        beep;
        WeisseKugel.RichtungTauschenMit (GelbeKugel);
      end
    else
      if GelbeKugel.Trifft(RoteKugel)
      then
        begin
          beep;
          GelbeKugel.RichtungTauschenMit (RoteKugel);
        end;
end;


end.
